#!/usr/bin/env python3
import os
import sys
parentdir = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
sys.path.insert(0, parentdir)
import time
import unittest
import microstacknode.gps.l80gps


class TestL80GPS(unittest.TestCase):
    def setUp(self):
        self.gps = microstacknode.gps.l80gps.L80GPS()

    # @unittest.skip('')
    def test_gpgll(self):
        print(self.gps.gpgll)

    # @unittest.skip('')
    # def test_locus_query(self):
    #     self.gps.locus_query()

    # @unittest.skip('')
    # def test_locus_erase(self):
    #     pass
    #     # self.gps.locus_erase()

    # def test_locus_start(self):
    #     self.gps.locus_start()

    # @unittest.skip('')
    # def test_locus_query_data(self):
    #     self.gps.locus_query_data()

    # def test_locus_query_data_and_parsing(self):
    #     # alternatively we can use this test data:
    #     #
    #     #     bytearray(b'\x01\x00\x01\x0b\x1f\x00\x00\x00\x0f\x00\x00\x00\x00\x00\x10\x0b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1f\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x00\x0c\x8c\x14\xdc\x99\xf3S\x02\xfb\xefUB\xfb\xd3\x0e\xc0\xe4\xff\x19\xf0\x99\xf3S\x02\r\xf0UB\'\xd5\x0e\xc0\xe4\xff\x06\xff\x99\xf3S\x02"\xf0UB\x98\xd1\x0e\xc0\xe6\xff\x9f\x0e\x9a\xf3S\x02Z\xf0UBa\xcf\x0e\xc0\xe7\xff\xf3\x1d\x9a\xf3S\x02F\xf0UB5\xcc\x0e\xc0\xe8\xff\xa4,\x9a\xf3S\x02V\xf0UB\xfb\xc9\x0e\xc0\xe9\xffO;\x9a\xf3S\x02I\xf0UB\xdb\xc7\x0e\xc0\xea\xffjJ\x9a\xf3S\x021\xf0UB\xd4\xc5\x0e\xc0\xeb\xffoY\x9a\xf3S\x02,\xf0UB\x05\xca\x0e\xc0\xeb\xff\xbfh\x9a\xf3S\x02T\xf0UB\xd3\xce\x0e\xc0\xed\xff"w\x9a\xf3S\x02s\xf0UB\xc6\xd1\x0e\xc0\xee\xff\x13\x86\x9a\xf3S\x02y\xf0UB,\xd3\x0e\xc0\xef\xff\x01\x95\x9a\xf3S\x02x\xf0UB\xef\xd2\x0e\xc0\xf0\xff\xce\xa4\x9a\xf3S\x02w\xf0UB\xeb\xd3\x0e\xc0\xf0\xff\xf5\xb3\x9a\xf3S\x02m\xf0UB\xc8\xd4\x0e\xc0\xf1\xff\xdd\xc2\x9a\xf3S\x02d\xf0UB\xc6\xd5\x0e\xc0\xf1\xff\xaa\xd1\x9a\xf3S\x02n\xf0UB\x86\xd7\x0e\xc0\xf2\xff\xf2\xe0\x9a\xf3S\x02g\xf0UB\xb4\xd4\x0e\xc0\xf4\xff\xfd\xef\x9a\xf3S\x02c\xf0UBV\xd1\x0e\xc0\xf4\xff\x11\xfe\x9a\xf3S\x02g\xf0UBC\xd1\x0e\xc0\xf5\xff\x10\r\x9b\xf3S\x02m\xf0UB!\xd0\x0e\xc0\xf6\xff\x88\x1c\x9b\xf3S\x02c\xf0UB\xf3\xcd\x0e\xc0\xf8\xffV+\x9b\xf3S\x02_\xf0UB3\xcd\x0e\xc0\xfa\xff\x9f:\x9b\xf3S\x02\\\xf0UB\x05\xcd\x0e\xc0\xfa\xff\xbbI\x9b\xf3S\x02n\xf0UB\xe1\xce\x0e\xc0\xfb\xff\x1cX\x9b\xf3S\x02j\xf0UB\xc6\xcf\x0e\xc0\xfd\xff)g\x9b\xf3S\x02c\xf0UB3\xd2\x0e\xc0\xff\xff\xf5v\x9b\xf3S\x02s\xf0UB\x1c\xd3\x0e\xc0\x00\x00\xda\x85\x9b\xf3S\x02w\xf0UB\x14\xd3\x0e\xc0\x00\x00%\x94\x9b\xf3S\x02p\xf0UB\'\xd0\x0e\xc0\x01\x00\x02\xa3\x9b\xf3S\x02Y\xf0UB\x07\xc9\x0e\xc0\x02\x00&\xb2\x9b\xf3S\x02E\xf0UB\x00\xc1\x0e\xc0\x04\x00"\xc1\x9b\xf3S\x028\xf0UB\xad\xbb\x0e\xc0\x05\x00\xfa\xf3\x9b\xf3S\x02\xe0\xefUB\x15\x9d\x0e\xc0\xff\xff\x94r\x9c\xf3S\x029\xf0UB\xe3\xc4\x0e\xc0\xf5\xffq\x81\x9c\xf3S\x02_\xf0UB\xba\xcc\x0e\xc0\xf4\xff\xb4\x90\x9c\xf3S\x02g\xf0UBp\xd3\x0e\xc0\xf4\xffH\x9f\x9c\xf3S\x02_\xf0UB7\xd9\x0e\xc0\xf3\xff5\xae\x9c\xf3S\x02\x94\xf0UBY\xe4\x0e\xc0\xf5\xff\x9a\xbd\x9c\xf3S\x02\xce\xf0UB$\xed\x0e\xc0\xf8\xff\xaa\xcc\x9c\xf3S\x02\xe5\xf0UB\x89\xf1\x0e\xc0\xfb\xffB\xdb\x9c\xf3S\x02\xb1\xf0UB\xac\xed\x0e\xc0\xfc\xff?\xea\x9c\xf3S\x02\x9f\xf0UB\xd2\xec\x0e\xc0\xfe\xff]\xf9\x9c\xf3S\x02\x7f\xf0UB\x12\xdc\x0e\xc0\x01\x00^\x08\x9d\xf3S\x02d\xf0UB\x14\xd8\x0e\xc0\x01\x00\xb7\x17\x9d\xf3S\x02F\xf0UB\xbe\xd4\x0e\xc0\x00\x00-&\x9d\xf3S\x02P\xf0UB\x9e\xd4\x0e\xc0\x02\x00(5\x9d\xf3S\x02\x93\xf0UB\xc5\xd1\x0e\xc0\x03\x00\xa7D\x9d\xf3S\x02\x9a\xf0UB1\xcd\x0e\xc0\x03\x007S\x9d\xf3S\x02\x7f\xf0UB\x15\xce\x0e\xc0\x05\x00\xe4b\x9d\xf3S\x02\x92\xf0UB\xc5\xca\x0e\xc0\x07\x00\xeeq\x9d\xf3S\x02\x88\xf0UB\xc5\xc5\x0e\xc0\x08\x00\xe7\x0c\x9e\xf3S\x02x\xf0UB\x8e\xbc\x0e\xc0\x02\x00Q\x1b\x9e\xf3S\x02\xa6\xf0UB\xd7\xcf\x0e\xc0\x02\x00\xb2*\x9e\xf3S\x02}\xf0UB\xaf\xd4\x0e\xc0\x02\x00;9\x9e\xf3S\x02o\xf0UB\x92\xd4\x0e\xc0\x02\x00\x07H\x9e\xf3S\x02\xad\xf0UB\xd9\xd3\x0e\xc0\x04\x00\xfeW\x9e\xf3S\x02\x82\xf0UB\xe3\xd6\x0e\xc0\x04\x00\xf1\xaf\x9e\xf3S\x02\xc4\xf0UB\xf5\xd5\x0e\xc0\x0c\x00R\xbe\x9e\xf3S\x02\xdc\xf0UB\x93\xd5\x0e\xc0\r\x00<\xcd\x9e\xf3S\x02\xa3\xf0UBL\xd8\x0e\xc0\x0f\x00\xe0\xdc\x9e\xf3S\x02\xad\xf0UB\xfe\xd5\x0e\xc0\x11\x00^\xeb\x9e\xf3S\x02\xd5\xf0UB(\xd1\x0e\xc0\x13\x00\xc1\xfa\x9e\xf3S\x02\xf2\xf0UB\xab\xce\x0e\xc0\x15\x00m\t\x9f\xf3S\x02\xcc\xf0UBj\xd2\x0e\xc0\x16\x00\x7f\x18\x9f\xf3S\x02\xbb\xf0UB\xcd\xd1\x0e\xc0\x18\x00\xb3\'\x9f\xf3S\x02\xda\xf0UB\xca\xd2\x0e\xc0\x19\x00\xe86\x9f\xf3S\x02\xf2\xf0UBd\xd3\x0e\xc0\x1a\x00}E\x9f\xf3S\x02\xbf\xf0UBj\xd1\x0e\xc0\x1b\x00Nq\x9f\xf3S\x02\x99\xf0UB\xad\xc5\x0e\xc0\x13\x00\x87\x80\x9f\xf3S\x02\xa6\xf0UB\xbd\xce\x0e\xc0\x15\x00T\x8f\x9f\xf3S\x02\xbb\xf0UB\xd0\xd1\x0e\xc0\x17\x006\x9e\x9f\xf3S\x02\xe8\xf0UB\xb2\xd5\x0e\xc0\x17\x00\x12\xad\x9f\xf3S\x02\xda\xf0UB2\xd5\x0e\xc0\x19\x00\x9d\xbc\x9f\xf3S\x02\xa4\xf0UBg\xd4\x0e\xc0\x1c\x00\xa3\xcb\x9f\xf3S\x02\xb7\xf0UB\x1d\xd4\x0e\xc0\x1e\x00\xbf\xda\x9f\xf3S\x02\xc6\xf0UB\xbf\xd3\x0e\xc0\x1f\x00{\xe9\x9f\xf3S\x02\xad\xf0UB^\xd2\x0e\xc0 \x00\xfc\xf8\x9f\xf3S\x02\xae\xf0UBf\xd3\x0e\xc0#\x00\xd4\x07\xa0\xf3S\x02\xc4\xf0UB*\xd4\x0e\xc0$\x002\x16\xa0\xf3S\x02\xcf\xf0UBM\xd4\x0e\xc0%\x00N%\xa0\xf3S\x02\x9c\xf0UB\xe7\xd2\x0e\xc0\'\x00\x804\xa0\xf3S\x02\x94\xf0UB\x01\xd2\x0e\xc0*\x00rC\xa0\xf3S\x02\x9a\xf0UBq\xd2\x0e\xc0,\x00}R\xa0\xf3S\x02\xa6\xf0UB\xee\xd2\x0e\xc0.\x00\xcda\xa0\xf3S\x02\x8d\xf0UBs\xd2\x0e\xc02\x00Tp\xa0\xf3S\x02\x89\xf0UB\xb7\xd0\x0e\xc06\x00\x83&\xa1\xf3S\x02l\xefUB\x88\x87\x0e\xc0\x04\x00t5\xa1\xf3S\x02\xe8\xefUB\x9d\xab\x0e\xc0\x04\x00\xdaK\xa1\xf3S\x02|\xf0UBZ\xc7\x0e\xc0\x01\x00\x81Z\xa1\xf3S\x02\xf5\xf0UB\xaf\xd2\x0e\xc0\x00\x00\xf8i\xa1\xf3S\x027\xf1UB\xfe\xd7\x0e\xc0\xff\xff\\x\xa1\xf3S\x02A\xf0UBg\xde\x0e\xc0\xfe\xff\xab\x8f\xa1\xf3S\x02k\xf1UB\xe3\xd5\x0e\xc0\x00\x00\xf9\xbf\xa1\xf3S\x02I\xf0UB\x9b\xd6\x0e\xc0\x05\x00\x94\xce\xa1\xf3S\x02O\xf0UB\xe2\xd6\x0e\xc0\x06\x00\x99\xdd\xa1\xf3S\x02X\xf0UBp\xd7\x0e\xc0\x06\x00\x0e\xfc\xa1\xf3S\x02q\xf1UB\xcd\xd3\x0e\xc0\t\x00\xb1\x0b\xa2\xf3S\x02c\xf1UBo\xd4\x0e\xc0\x0e\x00\xf5\x1a\xa2\xf3S\x02!\xf1UBH\xd5\x0e\xc0\x0e\x00\x80)\xa2\xf3S\x02\xc2\xf0UB\x1b\xd6\x0e\xc0\x11\x00\x1e:\xa2\xf3S\x02\x81\xf0UBS\xd7\x0e\xc0\x11\x00\x07I\xa2\xf3S\x02\xbd\xf0UB\xe1\xd5\x0e\xc0\x13\x00\xfaX\xa2\xf3S\x02\x08\xf1UB\x94\xd4\x0e\xc0\x15\x00-g\xa2\xf3S\x02\xd3\xf0UB\xbf\xd5\x0e\xc0\x19\x00\xeev\xa2\xf3S\x02\xde\xf0UBj\xd5\x0e\xc0\x1f\x00!\x85\xa2\xf3S\x02\xfd\xf0UB2\xd5\x0e\xc0 \x00\x96\x94\xa2\xf3S\x02\xf6\xf0UB\xed\xd5\x0e\xc0"\x00Q\xa3\xa2\xf3S\x02\n\xf1UB0\xd6\x0e\xc0$\x00C\xb2\xa2\xf3S\x02\x12\xf1UB|\xd5\x0e\xc0&\x00\x07\xc1\xa2\xf3S\x02\xe5\xf0UB\xe6\xd4\x0e\xc0(\x00\x17\xd0\xa2\xf3S\x02\xbe\xf0UB\xaa\xd5\x0e\xc0+\x00\x13\xdf\xa2\xf3S\x02\xcc\xf0UB\xd5\xd6\x0e\xc00\x00\t\xee\xa2\xf3S\x02\xca\xf0UB\xfd\xd6\x0e\xc05\x00\x13\xfd\xa2\xf3S\x02\xd4\xf0UB\xf2\xd7\x0e\xc08\x00\x1d\x0c\xa3\xf3S\x02\xd5\xf0UB`\xd8\x0e\xc0>\x00w\x1b\xa3\xf3S\x02\xd4\xf0UB\xf9\xd7\x0e\xc0D\x00\x8d*\xa3\xf3S\x02\xaa\xf0UB\xc3\xd7\x0e\xc0H\x00\xf49\xa3\xf3S\x02\xae\xf0UBF\xd7\x0e\xc0I\x00gH\xa3\xf3S\x02\x9b\xf0UB\xcf\xd6\x0e\xc0J\x00\xa8W\xa3\xf3S\x02\x9f\xf0UB/\xd7\x0e\xc0K\x00Sf\xa3\xf3S\x02\x80\xf0UB\xf9\xd7\x0e\xc0L\x00\xacu\xa3\xf3S\x02W\xf0UB\xeb\xd8\x0e\xc0M\x00t\x84\xa3\xf3S\x02k\xf0UB\xed\xd8\x0e\xc0M\x00\xbf\x93\xa3\xf3S\x02x\xf0UB\r\xd9\x0e\xc0N\x00Y\xa2\xa3\xf3S\x02\x82\xf0UB\xe5\xd8\x0e\xc0O\x00z\xb1\xa3\xf3S\x02l\xf0UB\xb6\xd9\x0e\xc0S\x00\xc9\xc0\xa3\xf3S\x02|\xf0UB\xd2\xd9\x0e\xc0T\x00\xcb\xcf\xa3\xf3S\x02r\xf0UB\xb9\xd9\x0e\xc0V\x00\xa3\xde\xa3\xf3S\x02~\xf0UB\r\xda\x0e\xc0U\x00\n\xed\xa3\xf3S\x02\x86\xf0UB\x95\xd9\x0e\xc0S\x00\\\xfc\xa3\xf3S\x02\x86\xf0UB\xda\xd9\x0e\xc0S\x00\x02\x0b\xa4\xf3S\x02\x87\xf0UB\x19\xd9\x0e\xc0R\x001\x1a\xa4\xf3S\x02|\xf0UBM\xd8\x0e\xc0S\x00\x8f)\xa4\xf3S\x02\x83\xf0UB\xfc\xd7\x0e\xc0R\x00\xfc8\xa4\xf3S\x02\x89\xf0UBl\xd8\x0e\xc0R\x00xG\xa4\xf3S\x02\x8d\xf0UB\n\xd8\x0e\xc0R\x00eV\xa4\xf3S\x02\x89\xf0UB&\xd8\x0e\xc0S\x00]e\xa4\xf3S\x02\xa1\xf0UB5\xd9\x0e\xc0R\x00Ut\xa4\xf3S\x02\xa3\xf0UB\xc3\xd9\x0e\xc0P\x00\xb2\x83\xa4\xf3S\x02\x8c\xf0UB\'\xd8\x0e\xc0Q\x00\x8e\x92\xa4\xf3S\x02\x8c\xf0UB\xff\xd6\x0e\xc0P\x00H\xa1\xa4\xf3S\x02\x84\xf0UB\xc8\xd6\x0e\xc0Q\x00E\xb0\xa4\xf3S\x02\x92\xf0UB`\xd8\x0e\xc0P\x00\xe5\xbf\xa4\xf3S\x02\xa3\xf0UBq\xd8\x0e\xc0N\x00\xd4\xce\xa4\xf3S\x02\x9b\xf0UB\xea\xd6\x0e\xc0O\x00\t\xdd\xa4\xf3S\x02\x94\xf0UB_\xd7\x0e\xc0P\x00\xbe\xec\xa4\xf3S\x02\xa8\xf0UB\xb3\xd9\x0e\xc0P\x00Q\xfb\xa4\xf3S\x02\xb4\xf0UB\xc7\xd9\x0e\xc0R\x00,\n\xa5\xf3S\x02\xc3\xf0UBQ\xda\x0e\xc0O\x00#\x19\xa5\xf3S\x02\xc5\xf0UB\xcb\xda\x0e\xc0O\x00\xac(\xa5\xf3S\x02\x9e\xf0UB=\xda\x0e\xc0S\x00,7\xa5\xf3S\x02\x95\xf0UB\xdf\xd9\x0e\xc0U\x00\xdfF\xa5\xf3S\x02\x98\xf0UB&\xd9\x0e\xc0V\x00YU\xa5\xf3S\x02\xc3\xf0UB\xd6\xd6\x0e\xc0V\x00\xee\xd4\xa6\xf3S\x02\xdb\xf0UB\xfc\xd6\x0e\xc0I\x00A\xe3\xa6\xf3S\x02\xe9\xf0UB\x16\xd9\x0e\xc0H\x00\xa0\xf2\xa6\xf3S\x02\xe6\xf0UBS\xda\x0e\xc0G\x00\xf7\x01\xa7\xf3S\x02\x9e\xf0UB\xee\xd9\x0e\xc0G\x00\xc3A\xa7\xf3S\x02\x86\xf0UB-\xd9\x0e\xc0K\x00TP\xa7\xf3S\x02\x90\xf0UB5\xdb\x0e\xc0K\x00I_\xa7\xf3S\x02\xae\xf0UBb\xda\x0e\xc0J\x00/n\xa7\xf3S\x02\x90\xf0UB\x0c\xda\x0e\xc0I\x00M}\xa7\xf3S\x02\x92\xf0UB\xc3\xd9\x0e\xc0I\x00\x90\x8c\xa7\xf3S\x02\x81\xf0UB\xd9\xd9\x0e\xc0I\x00h\x9b\xa7\xf3S\x02\x81\xf0UB\xa6\xd9\x0e\xc0I\x00\x00\xaa\xa7\xf3S\x02\x87\xf0UB\xb8\xd9\x0e\xc0J\x00*\xb9\xa7\xf3S\x02\xa0\xf0UB"\xd9\x0e\xc0I\x00\x87\xc8\xa7\xf3S\x02\xa9\xf0UB3\xd9\x0e\xc0G\x00\xe0\xd7\xa7\xf3S\x02\xc3\xf0UB\xc0\xd8\x0e\xc0D\x00d\xe6\xa7\xf3S\x02\xd5\xf0UB\xa6\xd8\x0e\xc0@\x00!\xf5\xa7\xf3S\x02\xd5\xf0UB\x0b\xd9\x0e\xc0?\x00\xe1\x04\xa8\xf3S\x02\xe2\xf0UBd\xd8\x0e\xc0=\x00D\x13\xa8\xf3S\x02\xde\xf0UB\x15\xd8\x0e\xc0;\x00\x18"\xa8\xf3S\x02\xcd\xf0UBJ\xd7\x0e\xc0;\x00j1\xa8\xf3S\x02\xc1\xf0UBA\xd6\x0e\xc0;\x00\x7f@\xa8\xf3S\x02\xbd\xf0UB\x88\xd5\x0e\xc0;\x00\xb8O\xa8\xf3S\x02\xb4\xf0UB.\xd6\x0e\xc0<\x00\x1c^\xa8\xf3S\x02\xaf\xf0UB\xc7\xd6\x0e\xc0<\x00\xffm\xa8\xf3S\x02\xad\xf0UB\xe9\xd6\x0e\xc0<\x00\xe0|\xa8\xf3S\x02\xac\xf0UB&\xd6\x0e\xc0<\x00?\x8b\xa8\xf3S\x02\xb5\xf0UB\x0c\xd7\x0e\xc0=\x00\xfb\x9a\xa8\xf3S\x02\xb5\xf0UB\xe3\xd6\x0e\xc0=\x00\x04\xa9\xa8\xf3S\x02\xaa\xf0UB\x02\xd7\x0e\xc0=\x00\xc8\xb8\xa8\xf3S\x02\xb1\xf0UBQ\xd6\x0e\xc0>\x00\x93\xc7\xa8\xf3S\x02\xa9\xf0UB^\xd6\x0e\xc0>\x00\xfb\xd6\xa8\xf3S\x02\xac\xf0UB\xbf\xd5\x0e\xc0?\x00\x0c\xe5\xa8\xf3S\x02\x96\xf0UB\xbd\xd6\x0e\xc0?\x00\x04\xf4\xa8\xf3S\x02\xaa\xf0UBo\xd7\x0e\xc0@\x00\x85\x03\xa9\xf3S\x02\xc4\xf0UB\xfa\xd6\x0e\xc0@\x00\x89\x12\xa9\xf3S\x02\xc9\xf0UBb\xd7\x0e\xc0@\x00\x0c!\xa9\xf3S\x02\xd7\xf0UB\x92\xd7\x0e\xc0@\x00\xd10\xa9\xf3S\x02\xe8\xf0UB\xf1\xd7\x0e\xc0@\x00\x9c?\xa9\xf3S\x02\xe4\xf0UB\xee\xd8\x0e\xc0A\x00\x8eN\xa9\xf3S\x02\xd7\xf0UB\xfe\xd7\x0e\xc0@\x00\xd2]\xa9\xf3S\x02\xe4\xf0UB\x8d\xd7\x0e\xc0A\x00\x80l\xa9\xf3S\x02\x0b\xf1UB\xa4\xd6\x0e\xc0A\x00w{\xa9\xf3S\x02%\xf1UBZ\xd6\x0e\xc0B\x00\xb3\x8a\xa9\xf3S\x02\r\xf1UB=\xd6\x0e\xc0B\x00\r\x99\xa9\xf3S\x02\xc5\xf0UB\x03\xdb\x0e\xc0E\x00\xe3\xa8\xa9\xf3S\x02\x85\xf0UBr\xdf\x0e\xc0G\x00\xe5\xb7\xa9\xf3S\x02y\xf0UB\x08\xdf\x0e\xc0J\x00q\xc6\xa9\xf3S\x02b\xf0UB.\xdc\x0e\xc0L\x008\xd5\xa9\xf3S\x02\\\xf0UB6\xda\x0e\xc0L\x00\x0b\xe4\xa9\xf3S\x02p\xf0UB~\xd9\x0e\xc0J\x00[\xf3\xa9\xf3S\x02x\xf0UB\xde\xda\x0e\xc0I\x00\xe4\x02\xaa\xf3S\x02\xac\xf0UB\xb2\xda\x0e\xc0J\x00\xad\x11\xaa\xf3S\x02\xa2\xf0UB\x9d\xdc\x0e\xc0K\x00\x98 \xaa\xf3S\x02\x91\xf0UB\xc6\xdc\x0e\xc0K\x00\xc1/\xaa\xf3S\x02\x82\xf0UB\xcf\xdc\x0e\xc0J\x00\xd5>\xaa\xf3S\x02\x8c\xf0UB\xad\xda\x0e\xc0K\x00\xafM\xaa\xf3S\x02\x85\xf0UB+\xdb\x0e\xc0L\x00U\\\xaa\xf3S\x02\xa2\xf0UB\xd4\xda\x0e\xc0M\x00\x9ck\xaa\xf3S\x02o\xf0UB\xba\xd9\x0e\xc0N\x00\x08z\xaa\xf3S\x02\xe3\xf0UB`\xd9\x0e\xc0N\x00O\x89\xaa\xf3S\x02\xef\xf0UB\x95\xda\x0e\xc0M\x00E\x98\xaa\xf3S\x02\xe3\xf0UB9\xdb\x0e\xc0M\x00\xf5\xa7\xaa\xf3S\x02\xd7\xf0UBt\xd8\x0e\xc0M\x00\xb0\xb6\xaa\xf3S\x02\xda\xf0UB\xe0\xd7\x0e\xc0M\x007\xc5\xaa\xf3S\x02\xd8\xf0UB\x06\xd8\x0e\xc0M\x00\xaf\xd4\xaa\xf3S\x02\xcd\xf0UB\x07\xd6\x0e\xc0L\x00\xa5\xe3\xaa\xf3S\x02\xd7\xf0UBq\xd7\x0e\xc0I\x00\xfa\xf2\xaa\xf3S\x02\xcf\xf0UBl\xd6\x0e\xc0I\x00\xef\x01\xab\xf3S\x02\xd4\xf0UB\xe1\xd6\x0e\xc0I\x00\x8b\x10\xab\xf3S\x02\xec\xf0UB\x00\xd8\x0e\xc0J\x00N\x1f\xab\xf3S\x02\xe0\xf0UB\xdf\xd8\x0e\xc0L\x00\x94.\xab\xf3S\x02\xe3\xf0UB\xe9\xd8\x0e\xc0M\x00\x91=\xab\xf3S\x02\xe2\xf0UBf\xda\x0e\xc0M\x00\x0eL\xab\xf3S\x02\xf0\xf0UB\xcf\xd9\x0e\xc0M\x00\xc7[\xab\xf3S\x02\xeb\xf0UB\xf0\xda\x0e\xc0N\x00\xf4j\xab\xf3S\x02\xda\xf0UB|\xd7\x0e\xc0O\x00ty\xab\xf3S\x02\xd0\xf0UB\x8b\xd7\x0e\xc0P\x00\x85\x88\xab\xf3S\x02\xd6\xf0UB\xc8\xd9\x0e\xc0Q\x00>\x97\xab\xf3S\x02\xde\xf0UBR\xdb\x0e\xc0R\x00\xb2\xa6\xab\xf3S\x02\xe8\xf0UB\xa0\xdb\x0e\xc0S\x00F\xb5\xab\xf3S\x02"\xf1UB\x08\xe2\x0e\xc0X\x00\x04\xc4\xab\xf3S\x02\x1c\xf1UB\xcc\xe2\x0e\xc0]\x00\x8a\xd3\xab\xf3S\x02/\xf1UB+\xe6\x0e\xc0c\x00s\xe2\xab\xf3S\x02C\xf1UB\x1d\xeb\x0e\xc0g\x00\x11\xf1\xab\xf3S\x02\'\xf1UBi\xe6\x0e\xc0h\x00\x10\x00\xac\xf3S\x02\x0f\xf1UB\x80\xe2\x0e\xc0j\x00!\x0f\xac\xf3S\x02\xfe\xf0UB\xa2\xe1\x0e\xc0j\x00\xff\x1e\xac\xf3S\x02\xfd\xf0UBU\xe1\x0e\xc0j\x00\x1a-\xac\xf3S\x02\x04\xf1UB\x92\xe1\x0e\xc0k\x00\x17<\xac\xf3S\x02\t\xf1UB\xe8\xdd\x0e\xc0l\x00JK\xac\xf3S\x02\x00\xf1UBY\xda\x0e\xc0l\x00\x82Z\xac\xf3S\x02\xfb\xf0UB\xcc\xd3\x0e\xc0l\x00\xf5i\xac\xf3S\x02\xeb\xf0UB\x87\xd5\x0e\xc0k\x00\x9cx\xac\xf3S\x02\xdd\xf0UB\xfd\xd5\x0e\xc0h\x00\xc2\x87\xac\xf3S\x02\xe2\xf0UB4\xd8\x0e\xc0e\x00\xcb\x96\xac\xf3S\x02\xff\xf0UB\xa3\xda\x0e\xc0d\x00S\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x02\x00\x01\x0b\x1f\x00\x00\x00\x0f\x00\x00\x00\x00\x00\x13\x0b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x00\xfc\x8c\x1c\xa5\xac\xf3S\x02\x10\xf1UB\xdc\xdc\x0e\xc0c\x00\xf0\xb4\xac\xf3S\x02\x17\xf1UB\x9c\xdd\x0e\xc0c\x00\xa7\xc3\xac\xf3S\x02\x18\xf1UB%\xde\x0e\xc0c\x00e\xd5\xac\xf3S\x02\x0c\xf1UB\x96\xde\x0e\xc0d\x00\xd3\xe4\xac\xf3S\x02\r\xf1UB\xc5\xdf\x0e\xc0e\x00\xb0\xf3\xac\xf3S\x02\t\xf1UB\xbe\xdf\x0e\xc0e\x00\xd8\x02\xad\xf3S\x02\x08\xf1UB\xba\xdf\x0e\xc0d\x00,\x11\xad\xf3S\x02\xf2\xf0UB<\xdd\x0e\xc0b\x00F \xad\xf3S\x02\xe4\xf0UBV\xdc\x0e\xc0`\x00\x08/\xad\xf3S\x02\xd3\xf0UBy\xda\x0e\xc0^\x00\'>\xad\xf3S\x02\xd3\xf0UBa\xd9\x0e\xc0]\x00.M\xad\xf3S\x02\xd5\xf0UB9\xd9\x0e\xc0\\\x00\x02\\\xad\xf3S\x02\xd6\xf0UB\xc3\xd9\x0e\xc0[\x00\xedk\xad\xf3S\x02\xd8\xf0UB\xcf\xd9\x0e\xc0[\x00\xd8z\xad\xf3S\x02\xdb\xf0UB\xaf\xd9\x0e\xc0Z\x00\xab\x89\xad\xf3S\x02\xda\xf0UB\x8a\xd9\x0e\xc0Z\x00|\x98\xad\xf3S\x02\xdb\xf0UB\xdc\xd9\x0e\xc0Z\x00:\xa7\xad\xf3S\x02\xdd\xf0UB\xb0\xd9\x0e\xc0Z\x00o\xb6\xad\xf3S\x02\xdc\xf0UB]\xd9\x0e\xc0Y\x00\x91\xc5\xad\xf3S\x02\xd8\xf0UB\xbf\xd8\x0e\xc0Y\x00\x05\xd4\xad\xf3S\x02\xdc\xf0UB\x1c\xd8\x0e\xc0Y\x00\xb3\xe3\xad\xf3S\x02\xde\xf0UB3\xd8\x0e\xc0Y\x00\xa9\xf2\xad\xf3S\x02\xe4\xf0UB\xce\xd7\x0e\xc0X\x00q\x01\xae\xf3S\x02\xe1\xf0UB\xab\xd7\x0e\xc0W\x00\xee\x10\xae\xf3S\x02\xdd\xf0UB\xe5\xd7\x0e\xc0W\x00\x8d\x1f\xae\xf3S\x02\xd9\xf0UB\x9e\xd7\x0e\xc0V\x00\xfc.\xae\xf3S\x02\xd9\xf0UB\xa4\xd8\x0e\xc0U\x00\xfb=\xae\xf3S\x02\xd9\xf0UB\x0e\xd9\x0e\xc0U\x00CL\xae\xf3S\x02\xd9\xf0UB\x84\xd8\x0e\xc0U\x00\xb9[\xae\xf3S\x02\xd8\xf0UB\xf6\xd7\x0e\xc0T\x00\xd3j\xae\xf3S\x02\xd6\xf0UB\x85\xd8\x0e\xc0T\x00\x90y\xae\xf3S\x02\xd9\xf0UB\xf9\xd7\x0e\xc0T\x00\xff\x88\xae\xf3S\x02\xd9\xf0UB\xbc\xd7\x0e\xc0T\x00K\x97\xae\xf3S\x02\xdf\xf0UB=\xd8\x0e\xc0S\x00\xdb\xa6\xae\xf3S\x02\xe3\xf0UBC\xd8\x0e\xc0S\x00\xa8\xb5\xae\xf3S\x02\xe3\xf0UB\x02\xd8\x0e\xc0T\x00\xfd\xc4\xae\xf3S\x02\xe7\xf0UB\xe0\xd7\x0e\xc0U\x00d\xd3\xae\xf3S\x02\xeb\xf0UB\xdb\xd7\x0e\xc0U\x00D\xe2\xae\xf3S\x02\xe9\xf0UB\xd6\xd7\x0e\xc0U\x00z\xf1\xae\xf3S\x02\xe7\xf0UB&\xd7\x0e\xc0U\x00\x97\x00\xaf\xf3S\x02\xdd\xf0UBx\xd6\x0e\xc0U\x00\x02\x0f\xaf\xf3S\x02\xdb\xf0UB:\xd6\x0e\xc0U\x00I\x1e\xaf\xf3S\x02\xda\xf0UBZ\xd6\x0e\xc0U\x009-\xaf\xf3S\x02\xd6\xf0UBA\xd6\x0e\xc0U\x00\x1d<\xaf\xf3S\x02\xd9\xf0UB\x8c\xd7\x0e\xc0U\x00\xcfK\xaf\xf3S\x02\xd6\xf0UB\xef\xd8\x0e\xc0U\x00\xdbZ\xaf\xf3S\x02\xc6\xf0UB\x14\xdb\x0e\xc0V\x00!i\xaf\xf3S\x02\xc7\xf0UB_\xda\x0e\xc0V\x00Yx\xaf\xf3S\x02\xd4\xf0UB\xbf\xd9\x0e\xc0U\x00\xbb\x87\xaf\xf3S\x02\xd3\xf0UB\xf2\xd9\x0e\xc0U\x00\x0e\x96\xaf\xf3S\x02\xce\xf0UB,\xdb\x0e\xc0U\x00\xde\xa5\xaf\xf3S\x02\xc4\xf0UB\x1e\xdc\x0e\xc0V\x00\xd1\xb4\xaf\xf3S\x02\xc8\xf0UB\xf7\xda\x0e\xc0U\x00 \xc3\xaf\xf3S\x02\xd2\xf0UB\xb6\xd9\x0e\xc0U\x00\x0f\xd2\xaf\xf3S\x02\xd9\xf0UB2\xda\x0e\xc0U\x00\x92\xe1\xaf\xf3S\x02\xd3\xf0UB\x91\xdb\x0e\xc0U\x00\t\xf0\xaf\xf3S\x02\xc9\xf0UB;\xdd\x0e\xc0V\x00\xad\xff\xaf\xf3S\x02\xcc\xf0UB\xef\xdb\x0e\xc0U\x00v\x0e\xb0\xf3S\x02\xcc\xf0UB\xb8\xda\x0e\xc0U\x00\xce\x1d\xb0\xf3S\x02\xcc\xf0UB\xb6\xdb\x0e\xc0T\x00\xd3,\xb0\xf3S\x02\xcc\xf0UB\xac\xdb\x0e\xc0T\x00\xf8;\xb0\xf3S\x02\xcc\xf0UB\x07\xdb\x0e\xc0T\x00DJ\xb0\xf3S\x02\xca\xf0UB\xfb\xda\x0e\xc0T\x00\xceY\xb0\xf3S\x02\xc6\xf0UBb\xda\x0e\xc0T\x00Hh\xb0\xf3S\x02\xcd\xf0UB\x87\xd9\x0e\xc0T\x00\x94w\xb0\xf3S\x02\xd0\xf0UBF\xd9\x0e\xc0T\x00W\x86\xb0\xf3S\x02\xd0\xf0UB\xa2\xd8\x0e\xc0S\x00D\x95\xb0\xf3S\x02\xca\xf0UB\x10\xd9\x0e\xc0S\x00\xfe\xa4\xb0\xf3S\x02\xc8\xf0UBS\xd9\x0e\xc0R\x00\x8f\xb3\xb0\xf3S\x02\xc9\xf0UB\xda\xd8\x0e\xc0R\x00\x11\xc2\xb0\xf3S\x02\xd0\xf0UB\t\xd7\x0e\xc0R\x00\xa5\xd1\xb0\xf3S\x02\xd4\xf0UB[\xd7\x0e\xc0R\x00\xe0\xe0\xb0\xf3S\x02\xd3\xf0UB+\xd8\x0e\xc0R\x00\xa9\xef\xb0\xf3S\x02\xd6\xf0UB\xd4\xd9\x0e\xc0R\x00]\xfe\xb0\xf3S\x02\xd7\xf0UBJ\xd9\x0e\xc0S\x00\xd2\r\xb1\xf3S\x02\xda\xf0UB4\xd8\x0e\xc0S\x00R\x1c\xb1\xf3S\x02\xda\xf0UB\xf2\xd6\x0e\xc0T\x00\x8c+\xb1\xf3S\x02\xd4\xf0UBt\xd4\x0e\xc0S\x006:\xb1\xf3S\x02\xce\xf0UB\x92\xd4\x0e\xc0S\x00\xdbI\xb1\xf3S\x02\xce\xf0UB\xb5\xd5\x0e\xc0T\x00\x89X\xb1\xf3S\x02\xd0\xf0UBW\xd6\x0e\xc0T\x00gg\xb1\xf3S\x02\xce\xf0UBs\xd7\x0e\xc0S\x00dv\xb1\xf3S\x02\xce\xf0UB\x18\xd8\x0e\xc0S\x00\x11\x85\xb1\xf3S\x02\xce\xf0UBJ\xd8\x0e\xc0R\x00\xb1\x94\xb1\xf3S\x02\xce\xf0UB(\xd8\x0e\xc0R\x00\xc2\xa3\xb1\xf3S\x02\xcf\xf0UB\xa5\xd8\x0e\xc0P\x00{\xb2\xb1\xf3S\x02\xd3\xf0UBe\xd8\x0e\xc0O\x00\xa9\xc1\xb1\xf3S\x02\xd3\xf0UB[\xd8\x0e\xc0O\x00\xe4\xd0\xb1\xf3S\x02\xce\xf0UB\x9b\xd8\x0e\xc0M\x00*\xdf\xb1\xf3S\x02\xc4\xf0UB\xcd\xda\x0e\xc0L\x00z\xee\xb1\xf3S\x02\xc4\xf0UB\x96\xdb\x0e\xc0K\x00\x16\xfd\xb1\xf3S\x02\xc5\xf0UB\xab\xdb\x0e\xc0K\x009\x0c\xb2\xf3S\x02\xc9\xf0UBV\xd9\x0e\xc0I\x00:\x1b\xb2\xf3S\x02\xc9\xf0UB\xbf\xd8\x0e\xc0I\x00\xc5*\xb2\xf3S\x02\xca\xf0UB\x89\xd8\x0e\xc0I\x00\xc19\xb2\xf3S\x02\xc4\xf0UB\xe7\xd9\x0e\xc0I\x00\xb3H\xb2\xf3S\x02\xc3\xf0UB\x00\xda\x0e\xc0I\x00!W\xb2\xf3S\x02\xc1\xf0UB\xba\xd8\x0e\xc0G\x00\x8af\xb2\xf3S\x02\xc4\xf0UBw\xd7\x0e\xc0F\x00}u\xb2\xf3S\x02\xc5\xf0UB#\xd7\x0e\xc0E\x008\x84\xb2\xf3S\x02\xc3\xf0UB\xb1\xd7\x0e\xc0F\x00^\x93\xb2\xf3S\x02\xc3\xf0UB\xfc\xd7\x0e\xc0F\x00\x04\xa2\xb2\xf3S\x02\xc2\xf0UB4\xd8\x0e\xc0G\x00\xf2\xb1\xb2\xf3S\x02\xc1\xf0UB\xf5\xd7\x0e\xc0E\x00.\xc0\xb2\xf3S\x02\xbe\xf0UB\x8a\xd8\x0e\xc0C\x00V\xcf\xb2\xf3S\x02\xc3\xf0UB\xdf\xd7\x0e\xc0A\x00|\xde\xb2\xf3S\x02\xc3\xf0UB\xa2\xd7\x0e\xc0A\x00\x10\xed\xb2\xf3S\x02\xc2\xf0UB3\xd8\x0e\xc0A\x00\xbc\xfc\xb2\xf3S\x02\xc4\xf0UB_\xd8\x0e\xc0A\x00\xc7\x0b\xb3\xf3S\x02\xc4\xf0UB\xa1\xd8\x0e\xc0B\x00\xcc\x1a\xb3\xf3S\x02\xc7\xf0UBh\xd9\x0e\xc0B\x00\x16)\xb3\xf3S\x02\xca\xf0UBb\xd9\x0e\xc0B\x00"8\xb3\xf3S\x02\xc7\xf0UB\x8b\xd9\x0e\xc0B\x00\xd7G\xb3\xf3S\x02\xc6\xf0UB\xc8\xd9\x0e\xc0C\x00\xebV\xb3\xf3S\x02\xca\xf0UB\xa6\xd9\x0e\xc0C\x00\x98e\xb3\xf3S\x02\xcd\xf0UB\xc2\xd9\x0e\xc0D\x00\xcft\xb3\xf3S\x02\xca\xf0UB\xd5\xd9\x0e\xc0D\x00\xce\x83\xb3\xf3S\x02\xc9\xf0UB0\xda\x0e\xc0D\x00\xdc\x92\xb3\xf3S\x02\xb6\xf0UB\x91\xdb\x0e\xc0D\x00\x12\xa1\xb3\xf3S\x02\xb4\xf0UB\x96\xdb\x0e\xc0C\x00#\xb0\xb3\xf3S\x02\xb6\xf0UB\xef\xda\x0e\xc0D\x00O\xbf\xb3\xf3S\x02\xb1\xf0UBQ\xdb\x0e\xc0D\x00\xf8\xce\xb3\xf3S\x02\xb4\xf0UB\x87\xdb\x0e\xc0E\x00[\xdd\xb3\xf3S\x02\xb5\xf0UB\x92\xdb\x0e\xc0D\x00]\xec\xb3\xf3S\x02\xb4\xf0UB\xa1\xdb\x0e\xc0C\x00Y\xfb\xb3\xf3S\x02\xb4\xf0UB"\xdc\x0e\xc0C\x00\xca\n\xb4\xf3S\x02\xb8\xf0UB\xd5\xdc\x0e\xc0D\x00\xc0\x19\xb4\xf3S\x02\xc2\xf0UB\xc9\xdd\x0e\xc0F\x00\xb6(\xb4\xf3S\x02\xc5\xf0UB\xdc\xdd\x0e\xc0F\x00\x957\xb4\xf3S\x02\xca\xf0UB\xc7\xdc\x0e\xc0H\x00\x91F\xb4\xf3S\x02\xcb\xf0UBx\xdc\x0e\xc0H\x00^U\xb4\xf3S\x02\xd0\xf0UB\xc8\xda\x0e\xc0H\x00\xe0d\xb4\xf3S\x02\xcf\xf0UB\xb3\xda\x0e\xc0G\x00\xbas\xb4\xf3S\x02\xcb\xf0UBk\xdb\x0e\xc0G\x00p\x82\xb4\xf3S\x02\xbf\xf0UB\x1e\xdb\x0e\xc0G\x00\x80\x91\xb4\xf3S\x02\xc6\xf0UBQ\xda\x0e\xc0G\x00\xa4\xa0\xb4\xf3S\x02\xc4\xf0UB\xbd\xda\x0e\xc0H\x00t\xaf\xb4\xf3S\x02\xb3\xf0UB\x0f\xdb\x0e\xc0H\x00\xbf\xbe\xb4\xf3S\x02\x95\xf0UB*\xdc\x0e\xc0H\x00\xaa\xcd\xb4\xf3S\x02\x9e\xf0UB\x15\xdc\x0e\xc0H\x00\xed\xdc\xb4\xf3S\x02\xa6\xf0UB\xac\xdb\x0e\xc0I\x00{\xeb\xb4\xf3S\x02\xa3\xf0UB\xf4\xdb\x0e\xc0I\x00\x11\xfa\xb4\xf3S\x02\xa1\xf0UB\xf4\xdb\x0e\xc0I\x00\x02\t\xb5\xf3S\x02\x9b\xf0UB{\xdb\x0e\xc0I\x00E\x18\xb5\xf3S\x02\x9c\xf0UBS\xdb\x0e\xc0I\x00{\'\xb5\xf3S\x02\xa3\xf0UB\x1e\xdb\x0e\xc0I\x0066\xb5\xf3S\x02\xb5\xf0UB\xe2\xd9\x0e\xc0I\x00\xcfE\xb5\xf3S\x02\xba\xf0UBa\xd9\x0e\xc0I\x000T\xb5\xf3S\x02\xc0\xf0UB<\xd9\x0e\xc0I\x00\x06c\xb5\xf3S\x02\xc4\xf0UB\xc5\xd9\x0e\xc0H\x00\xcdr\xb5\xf3S\x02\xc6\xf0UB\x14\xd8\x0e\xc0G\x00\x01\x81\xb5\xf3S\x02\xca\xf0UB\x10\xd8\x0e\xc0G\x00\xfa\x90\xb5\xf3S\x02\xcc\xf0UB\xd9\xd7\x0e\xc0F\x00*\x9f\xb5\xf3S\x02\xca\xf0UB\x89\xd8\x0e\xc0G\x00}\xae\xb5\xf3S\x02\xc8\xf0UB\x0c\xd8\x0e\xc0G\x00\xcb\xbd\xb5\xf3S\x02\xc6\xf0UB\'\xd8\x0e\xc0F\x00\xfc\xcc\xb5\xf3S\x02\xc1\xf0UB\xb7\xd8\x0e\xc0D\x00\x18\xdb\xb5\xf3S\x02\xc2\xf0UB\xa3\xd8\x0e\xc0D\x00\x18\xea\xb5\xf3S\x02\xca\xf0UB\xc4\xd7\x0e\xc0D\x00I\xf9\xb5\xf3S\x02\xcd\xf0UB\x16\xd8\x0e\xc0D\x00\x80\x08\xb6\xf3S\x02\xcc\xf0UBe\xd8\x0e\xc0C\x00\x07\x17\xb6\xf3S\x02\xce\xf0UBz\xd8\x0e\xc0B\x00\x04&\xb6\xf3S\x02\xcc\xf0UB\x05\xd9\x0e\xc0B\x00I5\xb6\xf3S\x02\xca\xf0UBA\xd9\x0e\xc0B\x00\x18D\xb6\xf3S\x02\xbe\xf0UB\xa5\xd9\x0e\xc0@\x00\xfbS\xb6\xf3S\x02\xbe\xf0UB\xe9\xd9\x0e\xc0@\x00\xa0b\xb6\xf3S\x02\xc2\xf0UB3\xda\x0e\xc0@\x004q\xb6\xf3S\x02\xc7\xf0UB\x0e\xda\x0e\xc0@\x00\x1f\x80\xb6\xf3S\x02\xcf\xf0UB\xf3\xd9\x0e\xc0A\x00\x19\x8f\xb6\xf3S\x02\xcb\xf0UB\x05\xda\x0e\xc0B\x00\xe4\x9e\xb6\xf3S\x02\xc4\xf0UB\x08\xda\x0e\xc0A\x00\xf4\xad\xb6\xf3S\x02\xc1\xf0UB@\xda\x0e\xc0A\x00\x8a\xbc\xb6\xf3S\x02\xbe\xf0UB\xa8\xd9\x0e\xc0@\x00\x0e\xcb\xb6\xf3S\x02\xb7\xf0UB\x9d\xd9\x0e\xc0?\x00:\xda\xb6\xf3S\x02\xac\xf0UBj\xdb\x0e\xc0>\x00\xc4\xe9\xb6\xf3S\x02\xa4\xf0UBQ\xdc\x0e\xc0=\x00\xc0\xf8\xb6\xf3S\x02\x9f\xf0UB\'\xdc\x0e\xc0<\x00\x9d\x07\xb7\xf3S\x02\xa2\xf0UB\x8b\xdc\x0e\xc0<\x00\xf2\x16\xb7\xf3S\x02\xa5\xf0UB\xfd\xdb\x0e\xc0<\x00\x95%\xb7\xf3S\x02\xa9\xf0UB\xde\xdb\x0e\xc0<\x00\x894\xb7\xf3S\x02\xb3\xf0UB\xe1\xda\x0e\xc0=\x00\xbdC\xb7\xf3S\x02\xb6\xf0UB\xf3\xda\x0e\xc0=\x00\xddR\xb7\xf3S\x02\xb6\xf0UB\xfd\xda\x0e\xc0=\x00\xc2a\xb7\xf3S\x02\xaf\xf0UB;\xdc\x0e\xc0<\x00)p\xb7\xf3S\x02\xaa\xf0UBR\xdd\x0e\xc0<\x00U\x7f\xb7\xf3S\x02\xaf\xf0UB\xc6\xdc\x0e\xc0<\x00\xca\x8e\xb7\xf3S\x02\xb5\xf0UBW\xda\x0e\xc0=\x00\xb7\x9d\xb7\xf3S\x02\xad\xf0UB\xde\xd9\x0e\xc0=\x006\xac\xb7\xf3S\x02\xaa\xf0UB\x01\xda\x0e\xc0=\x00\xdc\xbb\xb7\xf3S\x02\xa4\xf0UB\x89\xda\x0e\xc0=\x00M\xca\xb7\xf3S\x02\xa1\xf0UB\r\xdb\x0e\xc0=\x00\xbc\xd9\xb7\xf3S\x02\x92\xf0UB\xf5\xda\x0e\xc0=\x00e\xe8\xb7\xf3S\x02\x84\xf0UB\xa2\xda\x0e\xc0=\x00\x15\xf7\xb7\xf3S\x02\x83\xf0UBX\xda\x0e\xc0=\x00\xf7\x06\xb8\xf3S\x02\x98\xf0UBT\xda\x0e\xc0>\x00\x1d\x15\xb8\xf3S\x02\x96\xf0UB\xa0\xd9\x0e\xc0>\x00\xf7$\xb8\xf3S\x02\x8e\xf0UB+\xdb\x0e\xc0>\x00W3\xb8\xf3S\x02\x9e\xf0UBf\xdb\x0e\xc0>\x00\x1dB\xb8\xf3S\x02\x89\xf0UB\xcc\xda\x0e\xc0?\x00\xd1Q\xb8\xf3S\x02~\xf0UBh\xd9\x0e\xc0A\x00\xec\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff')
    #     #
    #     for d in self.gps.locus_query_data():
    #         print(d)


if __name__ == "__main__":
    unittest.main()
